/*
 * Copyright 2006 Robbie.JP
 */
package robbie.dao.x;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import robbie.dao.ResultSetHandlerArrayImpl;
import robbie.dao.ResultSetHandlerBeanListImpl;
import robbie.dao.ResultSetHandlerDynaBeanListImpl;
import robbie.dao.ResultSetHandlerMapListImpl;

/**
 * GeneralizedXDaoNXB<p>
 * <pre>
 * XDao͈ÖٓIȃgUNVŁÃ\bh1gUNVƂ
 * sĂ܂܂B(ACMTɂEJBł͕Kł͂܂)
 * ̌ʁAIɃgUNV邽߂ɂ́AXDaopgDao
 * 쐬Kv܂B
 * 
 * AgXDao͊gsȂĂAIȃgUNVsł悤
 * BaseDaoAPIpublicɂA܂gpConnectionoϐƂĕێ̂ɂȂ܂B
 * 
 * ɂāAOJTAȂǂgpĖIȃgUNVADao
 * gUNV̓Ƃ邱Ƃ\łB
 * 
 * ȉAR[fBOɂȂ܂B
 * 
 *         XDaoFactory factory = new XDaoFactory("etc/test-config.xml");
 *         GeneralizedXDao dao = (GeneralizedXDao)factory.createDaoInstance("GeneralizedXDao");
 *         
 *         try {
 *             // Connection̎擾
 *             dao.openConnection();
 *             dao.setAutoCommit(false);
 *             
 *             // p[^Map̐ݒ
 *             Map params = new HashMap();
 *             params.put("id", new Integer(4));
 *             params.put("name", "EEE");
 *             params.put("age",  new Integer(4));
 *             
 *             int count = dao.executeUpdate("test9", params);
 *             if (count != 1) {
 *                 dao.rollback();
 *             } else {
 *                 dao.commit();
 *             }
 *             
 *             System.out.println("updateCount=" + count);
 *             
 *         } catch(Exception ex) {
 *             try {
 *                 dao.rollback();
 *             } catch(Exception ex2) {
 *                 
 *             }
 *             throw ex;
 *         } finally {
 *             try {
 *                 // Connection
 *                 dao.closeConnection();
 *             } catch(Exception ex) {
 *                 // Ȃ
 *             }
 *         }
 * 
 * L̂悤GeneralizedXDaȍꍇɂ́ARlNVopen/closeAїO
 * ǗsKv܂Acommit/rollbackgp_ȏTuNX
 * 쐬ȂĂ\ɂȂ܂B
 * 
 * </pre>
 * @see robbie.dao.BaseDao
 * @see robbie.dao.x.XDao
 * @since 1.3.0
 * @deprecated
 * @author Tadahiro Murakami
 */
public class GeneralizedXDao extends XDao {

    private static final long serialVersionUID = -3455411682967958400L;
    private static final ResultSetHandlerMapListImpl mapListHandler = new ResultSetHandlerMapListImpl();
    private static final ResultSetHandlerDynaBeanListImpl dynaBeanListHandler = new ResultSetHandlerDynaBeanListImpl();
    private static final ResultSetHandlerArrayImpl arrayHandler = new ResultSetHandlerArrayImpl();

    /** Connectiontransient錾 */
    transient private Connection conn = null;
    
    /**
     * VKɃf[^x[XRlNVI[v܂B<p>
     * @throws SQLException
     */
    public void openConnection() throws SQLException {
        conn = resource.getConnection();
    }
    
    /**
     * GeneralizedXDaoێConnectionclose܂B<br>
     * @throws SQLException
     */
    public void closeConnection() throws SQLException {
        closeConnection(conn);
    }
    
    /**
     * GeneralizedXDaoێConnectionĂ邩mF܂B<p>
     * APICMTł́A܂삵Ȃ\܂B
     * @return ConnectionĂtrue
     * @throws SQLException
     */
    public boolean isClosed() throws SQLException {
        return isClosed(conn);
    }
    
    /**
     * GeneralizedXDaoێConnectionɃI[gR~bg[hZbg܂B<p>
     * @param isAutoCommit
     * @throws SQLException
     */
    public void setAutoCommit(boolean isAutoCommit) throws SQLException {
        setAutoCommit(conn, isAutoCommit);
    }
    
    /**
     * GeneralizedXDaoێConnectiongpăgUNVR~bg܂B<p>
     * @throws SQLException
     */
    public void commit() throws SQLException {
        commit(conn);
    }

    /**
     * GeneralizedXDaoێConnectiongpăgUNV[obN܂B<p>
     * @throws SQLException
     */
    public void rollback() throws SQLException {
        rollback(conn);
    }
    
    public List executeQuery(String id, Object beans) throws SQLException {
        return (List)executeQuery(conn, queryFactory.createQueryInstance(id, beans), mapListHandler);
    }
    
    public Object[][] executeQueryForArray(String id, Object beans) throws SQLException {
        return (Object[][])executeQuery(conn, queryFactory.createQueryInstance(id, beans), arrayHandler);
    }
    
    public List executeQueryForBeans(String id, Object beans) throws SQLException {
        return (List)executeQuery(conn, queryFactory.createQueryInstance(id, beans), new ResultSetHandlerBeanListImpl());
    }
    
    public List executeQueryForDynaBean(String id, Object beans) throws SQLException {
        return (List)executeQuery(conn, queryFactory.createQueryInstance(id, beans), dynaBeanListHandler);
    }
    
    public int executeUpdate(String id, Object beans) throws SQLException {
        return executeUpdate(conn, queryFactory.createQueryInstance(id, beans));
    }
}
