/*
 * Copyright 2007 Robbie.JP
 */
package robbie.util;

import java.lang.reflect.Method;
import java.util.Iterator;

/**
 * ListToStringInvocationHandlerNX.<p>
 * @author muramura
 */
public class ListToStringInvocationHandler extends BaseInvocationHandler {

    /**
     * RXgN^.<p>
     * @param obj
     */
    public ListToStringInvocationHandler(Object obj) {
        super(obj);
    }

    /* (non-Javadoc)
     * @see robbie.util.BaseInvocationHandler#invoke(java.lang.Object, java.lang.reflect.Method, java.lang.Object[])
     */
    public Object invoke(Object proxy, Method method, Object[] args) {
        
        if (!method.getName().equals("toString")) {
            return super.invoke(proxy, method, args);
        }
        
        if (beanObject instanceof java.util.List) {
            
            java.util.List list = (java.util.List)beanObject;
            
            String ls = System.getProperty("line.separator");
            StringBuffer buffer = new StringBuffer();
            
            buffer.append("List.size()=");
            buffer.append(list.size());
            buffer.append(ls);
            int i=0;
            for (Iterator it=list.iterator(); it.hasNext(); i++) {
                Object obj= it.next();
                buffer.append(i);
                buffer.append(") type:");
                buffer.append(obj.getClass().getName());
                buffer.append(" value:");
                buffer.append(obj);
                buffer.append(ls);
            }
            return buffer.toString();
        }
        return beanObject.toString();
    }
}
